FormManager.afterCreateAllForms.subscribe(function () {
	let formMaster = FormManager.byname('TnFpaDMFuncProcessoTrabTrib', '');
	let formCPF = FormManager.byname('TnFpaDMFuncProcessoTrabTribCPF', '');
	let formCOMPET = FormManager.byname('TnFpaDMFuncProcessoTrabTribCompet', '');
	let formCOMPL = FormManager.byname('TnFpaDMFuncProcessoTrabInfoIrCompl', '');
	let formDep = FormManager.byname('TnFpaDMFuncProcessoTrabInfoDep', '');

	formCPF.afterCreateGridConteudo.subscribe(() => {
		let gridCPF = dxDataGrid.getInstance($('#dataGridConteudoTnFpaDMFuncProcessoTrabTribCPF'));
		gridCPF.option("onRowClick", atualizarDetalhe);
	})

	formCOMPET.afterCreateGridConteudo.subscribe(() => {
		let gridCompet = dxDataGrid.getInstance($('#dataGridConteudoTnFpaDMFuncProcessoTrabTribCompet'));
		gridCompet.option("onRowClick", atualizarDetalheCompet);
	})

	formCOMPL.afterCreateGridConteudo.subscribe(() => {
		let gridCompl = dxDataGrid.getInstance($('#dataGridConteudoTnFpaDMFuncProcessoTrabInfoIrCompl'));
		gridCompl.option("onRowClick", atualizarDetalheCompl);
	})

	formMaster.afterDelete.subscribe(() => atualizarDetalhe());
	formCPF.afterDelete.subscribe(() => atualizarDetalhe());
	formCOMPET.afterDelete.subscribe(() => atualizarDetalheCompet());
	formCOMPL.afterDelete.subscribe(() => atualizarDetalheCompl());

	function atualizarDetalhe() {
		let gridCompet = dxDataGrid.getInstance('#dataGridConteudoTnFpaDMFuncProcessoTrabTribCompet');
		let gridCR = dxDataGrid.getInstance('#dataGridConteudoTnFpaDMFuncProcessoTrabTribCR');
		let gridCompl = dxDataGrid.getInstance('#dataGridConteudoTnFpaDMFuncProcessoTrabInfoIrCompl');
		let gridDep = dxDataGrid.getInstance('#dataGridConteudoTnFpaDMFuncProcessoTrabInfoDep');

		if (gridCompet) gridCompet.refresh();
		if (gridCR) gridCR.refresh();
		if (gridCompl) gridCompl.refresh();
		if (gridDep) gridDep.refresh();
	}

	function atualizarDetalheCompet() {
		let gridCR = dxDataGrid.getInstance('#dataGridConteudoTnFpaDMFuncProcessoTrabTribCR');
		if (gridCR) gridCR.refresh();
	}

	function atualizarDetalheCompl() {
		let gridDep = dxDataGrid.getInstance('#dataGridConteudoTnFpaDMFuncProcessoTrabInfoDep');
		if (gridDep) gridDep.refresh();
	}

	formMaster.AfterLoadDataSubject.subscribe(() => {
		validaDataConvivenciaProcTrabAjax();
	});

	const validaDataConvivenciaProcTrabAjax = function () {
		let params = JSON.stringify({
			'CODIGOEMPRESA': formMaster.getvalue('CODIGOEMPRESA')
		});

		KTApp.blockPage();
		AJaxCadastroExecuteMethodGetProperty('TnFpaDMeSocialProcTrab', 'ValidarDataConvivenciaProcTrabCloud', params, '', requestValidaDataConvivenciaProcTrabAjax);
		KTApp.unblockPage();
	}

	function requestValidaDataConvivenciaProcTrabAjax(retorno) {
		if (retorno) {
			let gridBaseCalculo = dxDataGrid.getInstance('#dataGridConteudoTnFpaDMFuncProcessoTrabTribCompet');
			gridBaseCalculo.option('stateStoring.enabled', false);
			gridBaseCalculo.columnOption('VRRENDIRRF', 'visible', retorno.data.result);
			gridBaseCalculo.columnOption('VRRENDIRRF13', 'visible', retorno.data.result);
		}
	}
});